package cvi10;

import redis.clients.jedis.Jedis;
import redis.clients.jedis.JedisPubSub;

public class ExampleApp {
	
	private static final String CHANNEL = "messages";

	public static void main(String[] args) {
		publisher();
		
		Jedis jedis = JedisConnectionFactory.newClient();
		jedis.subscribe(new JedisPubSub() {

			@Override
			public void onMessage(String channel, String message) {
				super.onMessage(channel, message);
				System.out.printf("[%s]: %s\n", channel, message);
			}
			
		}, CHANNEL);
		
	}

	private static void publisher() {
		Thread t = new Thread(() -> {
			try(Jedis jedis = JedisConnectionFactory.newClient()) {
				for(int i = 0; i < 10; i++) {
					jedis.publish(CHANNEL, "message"+i);
					sleep(500);
				}
			}
		});
		t.start();
	}

	private static void sleep(long ms) {
		try {
			Thread.sleep(ms);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	
}
